package com.example.pr01_uf6;

import com.example.pr01_uf6.utils.ConnectDB;
import com.example.pr01_uf6.utils.ConnectDB_2;
import com.example.pr01_uf6.utils.ConnectDB_3;
import com.example.pr01_uf6.utils.MySQLConnectionSettings_3;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.scene.control.ComboBox;
import javafx.scene.control.Label;
import javafx.scene.control.SplitPane;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.VBox;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.*;
import java.util.ArrayList;

public class HelloController {

    @FXML
    public ComboBox comboboxDB = new ComboBox();

    @FXML
    ComboBox comboboxTable = new ComboBox();

    @FXML
    GridPane data = new GridPane();

    protected void setData(){
        for (int i = 0; i < data.getColumnCount(); i++) {
            for (int j = 0; j < data.getRowCount(); j++) {

            }
        }
    }

    @FXML
    private Label welcomeText;

    @FXML
    private VBox vBoxBackground;

    @FXML
    protected void onHelloButtonClick() {
        welcomeText.setText("Welcome to JavaFX Application!");
    }

    @FXML
    protected void vBoxBackground(){
        vBoxBackground.setStyle("-fx-background-color: blue;");
    }

    private String selectedDB;
    private String selectedDB_2;
    private ArrayList <String> array = new ArrayList<>();

    @FXML
    protected void initialize(){
        try {
            Class.forName("com.mysql.jdbc.Driver");
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }

        boolean sortir = false;
        /*
         * try-catch with resources: BufferedReader i Connection
         */
        try (BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
             Connection con = ConnectDB.getInstance()) {
            addDBTitlesToCombobox(con, in);

        } catch (IOException e) {
            System.out.println("Error " + e.getClass().getName() + " , quiting.");
            System.out.println("Message: " + e.getMessage());
        } catch (Exception e) {
            System.out.println("Error closing resource " + e.getClass().getName());
            System.out.println("Message: " + e.getMessage());
        } finally {
            try {
                ConnectDB.closeConnection();
            } catch (SQLException e) {
                System.out.println("Error closing resource " + e.getClass().getName());
            }
        }
    }

    @FXML
    protected void onClickDBComboBox(){
        selectedDB = (String) comboboxDB.getValue();
        System.out.println(selectedDB);

        try {
            Class.forName("com.mysql.jdbc.Driver");
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }

        boolean sortir = false;
        try (BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
             Connection con = ConnectDB_2.getInstance()) {
            addTablesTitlesToCombobox(con, in);

        } catch (IOException e) {
            System.out.println("Error " + e.getClass().getName() + " , quiting.");
            System.out.println("Message: " + e.getMessage());
        } catch (Exception e) {
            System.out.println("Error closing resource " + e.getClass().getName());
            System.out.println("Message: " + e.getMessage());
        } finally {
            try {
                ConnectDB_2.closeConnection();
            } catch (SQLException e) {
                System.out.println("Error closing resource " + e.getClass().getName());
            }
        }
    }

    @FXML
    protected void initialize_3(){

        selectedDB_2 = (String) comboboxTable.getValue();
        System.out.println(selectedDB_2);

        try {
            Class.forName("com.mysql.jdbc.Driver");
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }

        boolean sortir = false;
        /*
         * try-catch with resources: BufferedReader i Connection
         */
        try (BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
             Connection con = ConnectDB_3.getInstance()) {
            fillGridWithTables(con, in);

        } catch (IOException e) {
            System.out.println("Error " + e.getClass().getName() + " , quiting.");
            System.out.println("Message: " + e.getMessage());
        } catch (Exception e) {
            System.out.println("Error closing resource " + e.getClass().getName());
            System.out.println("Message: " + e.getMessage());
        } finally {
            try {
                ConnectDB.closeConnection();
            } catch (SQLException e) {
                System.out.println("Error closing resource " + e.getClass().getName());
            }
        }
    }

    public void addDBTitlesToCombobox(Connection con, BufferedReader in) throws IOException, Exception {
        String query = "SELECT table_schema FROM tables GROUP BY table_schema";
        try (
                Statement stmt = con.createStatement();
                ResultSet rs = stmt.executeQuery(query)){
            while (rs.next()) {
                comboboxDB.getItems().add(rs.getString("table_schema"));
            }
        } catch (SQLException ex) {
            throw new Exception("Error reading records table PRODUCTS", ex);
        }
    }

    public void addTablesTitlesToCombobox(Connection con, BufferedReader in) throws IOException, Exception {
        String query = "SELECT table_name FROM tables Where table_schema = '" + selectedDB + "'";
        try (
                Statement stmt_2 = con.createStatement();
                ResultSet rs_2 = stmt_2.executeQuery(query)){
            while (rs_2.next()) {
                comboboxTable.getItems().add(rs_2.getString("table_name"));
            }
        } catch (SQLException ex) {
            throw new Exception("Error reading records table", ex);
        } finally {
            con.close();
        }
    }

    public void fillGridWithTables(Connection con, BufferedReader in) throws IOException, Exception {

        String query = "SELECT column_name FROM columns WHERE TABLE_SCHEMA = '" + selectedDB + "' AND table_name = '" + selectedDB_2 + "'";
        try (
                Statement stmt_3 = con.createStatement();
                ResultSet rs_3 = stmt_3.executeQuery(query)){
            while (rs_3.next()) {
                array.add(rs_3.getString("table_name"));
                System.out.println(rs_3.getString("table_name"));
            }
        } catch (SQLException ex) {
            throw new Exception("Error reading records table", ex);
        } finally {
            con.close();
        }
    }
}